Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -1791,183 +2486,183 @@
 {
 
-	atom *Walker = NULL, *OtherWalker = NULL, *Candidate = NULL;
-	int No, NoBonds, CandidateBondNo;
-	int NumberCells, divisor[NDIM], n[NDIM], N[NDIM], index, Index, j;
-	molecule **CellList;
-	double distance, MinDistance, MaxDistance;
-	double *matrix = ReturnFullMatrixforSymmetric(cell_size);
-	Vector x;
-	int FalseBondDegree = 0;
-
-	BondDistance = bonddistance; // * ((IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem);
-	*out << Verbose(0) << "Begin of CreateAdjacencyList." << endl;
-	// remove every bond from the list
-	if ((first->next != last) && (last->previous != first)) {	// there are bonds present
-		cleanup(first,last);
-	}
-
-	// count atoms in molecule = dimension of matrix (also give each unique name and continuous numbering)
-	CountAtoms(out);
-	*out << Verbose(1) << "AtomCount " << AtomCount << "." << endl;
-
-	if (AtomCount != 0) {
-		// 1. find divisor for each axis, such that a sphere with radius of at least bonddistance can be placed into each cell
-		j=-1;
-		for (int i=0;i<NDIM;i++) {
-			j += i+1;
-			divisor[i] = (int)floor(cell_size[j]/bonddistance); // take smaller value such that size of linked cell is at least bonddistance
-			//*out << Verbose(1) << "divisor[" << i << "]	= " << divisor[i] << "." << endl;
-		}
-		// 2a. allocate memory for the cell list
-		NumberCells = divisor[0]*divisor[1]*divisor[2];
-		*out << Verbose(1) << "Allocating " << NumberCells << " cells." << endl;
-		CellList = (molecule **) Malloc(sizeof(molecule *)*NumberCells, "molecule::CreateAdjacencyList - ** CellList");
-		for (int i=NumberCells;i--;)
-			CellList[i] = NULL;
-
-		// 2b. put all atoms into its corresponding list
-		Walker = start;
-		while(Walker->next != end) {
-			Walker = Walker->next;
-			//*out << Verbose(1) << "Current atom is " << *Walker << " with coordinates ";
-			//Walker->x.Output(out);
-			//*out << "." << endl;
-			// compute the cell by the atom's coordinates
-			j=-1;
-			for (int i=0;i<NDIM;i++) {
-				j += i+1;
-				x.CopyVector(&(Walker->x));
-				x.KeepPeriodic(out, matrix);
-				n[i] = (int)floor(x.x[i]/cell_size[j]*(double)divisor[i]);
-			}
-			index = n[2] + (n[1] + n[0] * divisor[1]) * divisor[2];
-			//*out << Verbose(1) << "Atom " << *Walker << " goes into cell number [" << n[0] << "," << n[1] << "," << n[2] << "] = " << index << "." << endl;
-			// add copy atom to this cell
-			if (CellList[index] == NULL)	// allocate molecule if not done
-				CellList[index] = new molecule(elemente);
-			OtherWalker = CellList[index]->AddCopyAtom(Walker); // add a copy of walker to this atom, father will be walker for later reference
-			//*out << Verbose(1) << "Copy Atom is " << *OtherWalker << "." << endl;
-		}
-		//for (int i=0;i<NumberCells;i++)
-			//*out << Verbose(1) << "Cell number " << i << ": " << CellList[i] << "." << endl;
-
-
-		// 3a. go through every cell
-		for (N[0]=divisor[0];N[0]--;)
-			for (N[1]=divisor[1];N[1]--;)
-				for (N[2]=divisor[2];N[2]--;) {
-					Index = N[2] + (N[1] + N[0] * divisor[1]) * divisor[2];
-					if (CellList[Index] != NULL) { // if there atoms in this cell
-						//*out << Verbose(1) << "Current cell is " << Index << "." << endl;
-						// 3b. for every atom therein
-						Walker = CellList[Index]->start;
-						while (Walker->next != CellList[Index]->end) {	// go through every atom
-							Walker = Walker->next;
-							//*out << Verbose(0) << "Current Atom is " << *Walker << "." << endl;
-							// 3c. check for possible bond between each atom in this and every one in the 27 cells
-							for (n[0]=-1;n[0]<=1;n[0]++)
-								for (n[1]=-1;n[1]<=1;n[1]++)
-									for (n[2]=-1;n[2]<=1;n[2]++) {
-										 // compute the index of this comparison cell and make it periodic
-										index = ((N[2]+n[2]+divisor[2])%divisor[2]) + (((N[1]+n[1]+divisor[1])%divisor[1]) + ((N[0]+n[0]+divisor[0])%divisor[0]) * divisor[1]) * divisor[2];
-										//*out << Verbose(1) << "Number of comparison cell is " << index << "." << endl;
-										if (CellList[index] != NULL) {	// if there are any atoms in this cell
-											OtherWalker = CellList[index]->start;
-											while(OtherWalker->next != CellList[index]->end) {	// go through every atom in this cell
-												OtherWalker = OtherWalker->next;
-												//*out << Verbose(0) << "Current comparison atom is " << *OtherWalker << "." << endl;
-												/// \todo periodic check is missing here!
-												//*out << Verbose(1) << "Checking distance " << OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size) << " against typical bond length of " << bonddistance*bonddistance << "." << endl;
-												MinDistance = OtherWalker->type->CovalentRadius + Walker->type->CovalentRadius;
-												MinDistance *= (IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem;
-												MaxDistance = MinDistance + BONDTHRESHOLD;
-												MinDistance -= BONDTHRESHOLD;
-												distance = OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size);
-												if ((OtherWalker->father->nr > Walker->father->nr) && (distance <= MaxDistance*MaxDistance) && (distance >= MinDistance*MinDistance)) { // create bond if distance is smaller
-													//*out << Verbose(1) << "Adding Bond between " << *Walker << " and " << *OtherWalker << " in distance " << sqrt(distance) << "." << endl;
-													AddBond(Walker->father, OtherWalker->father, 1);	// also increases molecule::BondCount
-												} else {
-													//*out << Verbose(1) << "Not Adding: Wrong label order or distance too great." << endl;
-												}
-											}
-										}
-									}
-						}
-					}
-				}
-
-
-
-		// 4. free the cell again
-		for (int i=NumberCells;i--;)
-			if (CellList[i] != NULL) {
-				delete(CellList[i]);
-			}
-		Free((void **)&CellList, "molecule::CreateAdjacencyList - ** CellList");
-
-		// create the adjacency list per atom
-		CreateListOfBondsPerAtom(out);
-
-		// correct Bond degree of each bond by checking both bond partners for a mismatch between valence and current sum of bond degrees,
-		// iteratively increase the one first where the other bond partner has the fewest number of bonds (i.e. in general bonds oxygene
-		// preferred over carbon bonds). Beforehand, we had picked the first mismatching partner, which lead to oxygenes with single instead of
-		// double bonds as was expected.
-		if (BondCount != 0) {
-			NoCyclicBonds = 0;
-			*out << Verbose(1) << "Correcting Bond degree of each bond ... ";
-			do {
-				No = 0; // No acts as breakup flag (if 1 we still continue)
-				Walker = start;
-				while (Walker->next != end) { // go through every atom
-					Walker = Walker->next;
-					// count valence of first partner
-					NoBonds = 0;
-					for(j=0;j<NumberOfBondsPerAtom[Walker->nr];j++)
-						NoBonds += ListOfBondsPerAtom[Walker->nr][j]->BondDegree;
-					*out << Verbose(3) << "Walker " << *Walker << ": " << (int)Walker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
-					if ((int)(Walker->type->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
-						Candidate = NULL;
-						CandidateBondNo = -1;
-						for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) { // go through each of its bond partners
-							OtherWalker = ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
-							// count valence of second partner
-							NoBonds = 0;
-							for(j=0;j<NumberOfBondsPerAtom[OtherWalker->nr];j++)
-								NoBonds += ListOfBondsPerAtom[OtherWalker->nr][j]->BondDegree;
-							*out << Verbose(3) << "OtherWalker " << *OtherWalker << ": " << (int)OtherWalker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
-							if ((int)(OtherWalker->type->NoValenceOrbitals) > NoBonds) { // check if possible candidate
-								if ((Candidate == NULL) || (NumberOfBondsPerAtom[Candidate->nr] > NumberOfBondsPerAtom[OtherWalker->nr])) { // pick the one with fewer number of bonds first
-									Candidate = OtherWalker;
-									CandidateBondNo = i;
-									*out << Verbose(3) << "New candidate is " << *Candidate << "." << endl;
-								}
-							}
-						}
-						if ((Candidate != NULL) && (CandidateBondNo != -1)) {
-							ListOfBondsPerAtom[Walker->nr][CandidateBondNo]->BondDegree++;
-							*out << Verbose(2) << "Increased bond degree for bond " << *ListOfBondsPerAtom[Walker->nr][CandidateBondNo] << "." << endl;
-						} else
-							*out << Verbose(2) << "Could not find correct degree for atom " << *Walker << "." << endl;
-							FalseBondDegree++;
-					}
-				}
-			} while (No);
-		*out << " done." << endl;
-		} else
-			*out << Verbose(1) << "BondCount is " << BondCount << ", no bonds between any of the " << AtomCount << " atoms." << endl;
-		*out << Verbose(1) << "I detected " << BondCount << " bonds in the molecule with distance " << bonddistance << ", " << FalseBondDegree << " bonds could not be corrected." << endl;
-
-		// output bonds for debugging (if bond chain list was correctly installed)
-		*out << Verbose(1) << endl << "From contents of bond chain list:";
-		bond *Binder = first;
-		while(Binder->next != last) {
-			Binder = Binder->next;
-			*out << *Binder << "\t" << endl;
-		}
-		*out << endl;
-	} else
-		*out << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl;
-	*out << Verbose(0) << "End of CreateAdjacencyList." << endl;
-	Free((void **)&matrix, "molecule::CreateAdjacencyList: *matrix");
+  atom *Walker = NULL, *OtherWalker = NULL, *Candidate = NULL;
+  int No, NoBonds, CandidateBondNo;
+  int NumberCells, divisor[NDIM], n[NDIM], N[NDIM], index, Index, j;
+  molecule **CellList;
+  double distance, MinDistance, MaxDistance;
+  double *matrix = ReturnFullMatrixforSymmetric(cell_size);
+  Vector x;
+  int FalseBondDegree = 0;
+
+  BondDistance = bonddistance; // * ((IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem);
+  *out << Verbose(0) << "Begin of CreateAdjacencyList." << endl;
+  // remove every bond from the list
+  if ((first->next != last) && (last->previous != first)) {  // there are bonds present
+    cleanup(first,last);
+  }
+
+  // count atoms in molecule = dimension of matrix (also give each unique name and continuous numbering)
+  CountAtoms(out);
+  *out << Verbose(1) << "AtomCount " << AtomCount << "." << endl;
+
+  if (AtomCount != 0) {
+    // 1. find divisor for each axis, such that a sphere with radius of at least bonddistance can be placed into each cell
+    j=-1;
+    for (int i=0;i<NDIM;i++) {
+      j += i+1;
+      divisor[i] = (int)floor(cell_size[j]/bonddistance); // take smaller value such that size of linked cell is at least bonddistance
+      //*out << Verbose(1) << "divisor[" << i << "]  = " << divisor[i] << "." << endl;
+    }
+    // 2a. allocate memory for the cell list
+    NumberCells = divisor[0]*divisor[1]*divisor[2];
+    *out << Verbose(1) << "Allocating " << NumberCells << " cells." << endl;
+    CellList = (molecule **) Malloc(sizeof(molecule *)*NumberCells, "molecule::CreateAdjacencyList - ** CellList");
+    for (int i=NumberCells;i--;)
+      CellList[i] = NULL;
+
+    // 2b. put all atoms into its corresponding list
+    Walker = start;
+    while(Walker->next != end) {
+      Walker = Walker->next;
+      //*out << Verbose(1) << "Current atom is " << *Walker << " with coordinates ";
+      //Walker->x.Output(out);
+      //*out << "." << endl;
+      // compute the cell by the atom's coordinates
+      j=-1;
+      for (int i=0;i<NDIM;i++) {
+        j += i+1;
+        x.CopyVector(&(Walker->x));
+        x.KeepPeriodic(out, matrix);
+        n[i] = (int)floor(x.x[i]/cell_size[j]*(double)divisor[i]);
+      }
+      index = n[2] + (n[1] + n[0] * divisor[1]) * divisor[2];
+      //*out << Verbose(1) << "Atom " << *Walker << " goes into cell number [" << n[0] << "," << n[1] << "," << n[2] << "] = " << index << "." << endl;
+      // add copy atom to this cell
+      if (CellList[index] == NULL)  // allocate molecule if not done
+        CellList[index] = new molecule(elemente);
+      OtherWalker = CellList[index]->AddCopyAtom(Walker); // add a copy of walker to this atom, father will be walker for later reference
+      //*out << Verbose(1) << "Copy Atom is " << *OtherWalker << "." << endl;
+    }
+    //for (int i=0;i<NumberCells;i++)
+      //*out << Verbose(1) << "Cell number " << i << ": " << CellList[i] << "." << endl;
+
+
+    // 3a. go through every cell
+    for (N[0]=divisor[0];N[0]--;)
+      for (N[1]=divisor[1];N[1]--;)
+        for (N[2]=divisor[2];N[2]--;) {
+          Index = N[2] + (N[1] + N[0] * divisor[1]) * divisor[2];
+          if (CellList[Index] != NULL) { // if there atoms in this cell
+            //*out << Verbose(1) << "Current cell is " << Index << "." << endl;
+            // 3b. for every atom therein
+            Walker = CellList[Index]->start;
+            while (Walker->next != CellList[Index]->end) {  // go through every atom
+              Walker = Walker->next;
+              //*out << Verbose(0) << "Current Atom is " << *Walker << "." << endl;
+              // 3c. check for possible bond between each atom in this and every one in the 27 cells
+              for (n[0]=-1;n[0]<=1;n[0]++)
+                for (n[1]=-1;n[1]<=1;n[1]++)
+                  for (n[2]=-1;n[2]<=1;n[2]++) {
+                     // compute the index of this comparison cell and make it periodic
+                    index = ((N[2]+n[2]+divisor[2])%divisor[2]) + (((N[1]+n[1]+divisor[1])%divisor[1]) + ((N[0]+n[0]+divisor[0])%divisor[0]) * divisor[1]) * divisor[2];
+                    //*out << Verbose(1) << "Number of comparison cell is " << index << "." << endl;
+                    if (CellList[index] != NULL) {  // if there are any atoms in this cell
+                      OtherWalker = CellList[index]->start;
+                      while(OtherWalker->next != CellList[index]->end) {  // go through every atom in this cell
+                        OtherWalker = OtherWalker->next;
+                        //*out << Verbose(0) << "Current comparison atom is " << *OtherWalker << "." << endl;
+                        /// \todo periodic check is missing here!
+                        //*out << Verbose(1) << "Checking distance " << OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size) << " against typical bond length of " << bonddistance*bonddistance << "." << endl;
+                        MinDistance = OtherWalker->type->CovalentRadius + Walker->type->CovalentRadius;
+                        MinDistance *= (IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem;
+                        MaxDistance = MinDistance + BONDTHRESHOLD;
+                        MinDistance -= BONDTHRESHOLD;
+                        distance = OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size);
+                        if ((OtherWalker->father->nr > Walker->father->nr) && (distance <= MaxDistance*MaxDistance) && (distance >= MinDistance*MinDistance)) { // create bond if distance is smaller
+                          //*out << Verbose(1) << "Adding Bond between " << *Walker << " and " << *OtherWalker << " in distance " << sqrt(distance) << "." << endl;
+                          AddBond(Walker->father, OtherWalker->father, 1);  // also increases molecule::BondCount
+                        } else {
+                          //*out << Verbose(1) << "Not Adding: Wrong label order or distance too great." << endl;
+                        }
+                      }
+                    }
+                  }
+            }
+          }
+        }
+
+
+
+    // 4. free the cell again
+    for (int i=NumberCells;i--;)
+      if (CellList[i] != NULL) {
+        delete(CellList[i]);
+      }
+    Free((void **)&CellList, "molecule::CreateAdjacencyList - ** CellList");
+
+    // create the adjacency list per atom
+    CreateListOfBondsPerAtom(out);
+
+    // correct Bond degree of each bond by checking both bond partners for a mismatch between valence and current sum of bond degrees,
+    // iteratively increase the one first where the other bond partner has the fewest number of bonds (i.e. in general bonds oxygene
+    // preferred over carbon bonds). Beforehand, we had picked the first mismatching partner, which lead to oxygenes with single instead of
+    // double bonds as was expected.
+    if (BondCount != 0) {
+      NoCyclicBonds = 0;
+      *out << Verbose(1) << "Correcting Bond degree of each bond ... ";
+      do {
+        No = 0; // No acts as breakup flag (if 1 we still continue)
+        Walker = start;
+        while (Walker->next != end) { // go through every atom
+          Walker = Walker->next;
+          // count valence of first partner
+          NoBonds = 0;
+          for(j=0;j<NumberOfBondsPerAtom[Walker->nr];j++)
+            NoBonds += ListOfBondsPerAtom[Walker->nr][j]->BondDegree;
+          *out << Verbose(3) << "Walker " << *Walker << ": " << (int)Walker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
+          if ((int)(Walker->type->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
+            Candidate = NULL;
+            CandidateBondNo = -1;
+            for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) { // go through each of its bond partners
+              OtherWalker = ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
+              // count valence of second partner
+              NoBonds = 0;
+              for(j=0;j<NumberOfBondsPerAtom[OtherWalker->nr];j++)
+                NoBonds += ListOfBondsPerAtom[OtherWalker->nr][j]->BondDegree;
+              *out << Verbose(3) << "OtherWalker " << *OtherWalker << ": " << (int)OtherWalker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
+              if ((int)(OtherWalker->type->NoValenceOrbitals) > NoBonds) { // check if possible candidate
+                if ((Candidate == NULL) || (NumberOfBondsPerAtom[Candidate->nr] > NumberOfBondsPerAtom[OtherWalker->nr])) { // pick the one with fewer number of bonds first
+                  Candidate = OtherWalker;
+                  CandidateBondNo = i;
+                  *out << Verbose(3) << "New candidate is " << *Candidate << "." << endl;
+                }
+              }
+            }
+            if ((Candidate != NULL) && (CandidateBondNo != -1)) {
+              ListOfBondsPerAtom[Walker->nr][CandidateBondNo]->BondDegree++;
+              *out << Verbose(2) << "Increased bond degree for bond " << *ListOfBondsPerAtom[Walker->nr][CandidateBondNo] << "." << endl;
+            } else
+              *out << Verbose(2) << "Could not find correct degree for atom " << *Walker << "." << endl;
+              FalseBondDegree++;
+          }
+        }
+      } while (No);
+    *out << " done." << endl;
+    } else
+      *out << Verbose(1) << "BondCount is " << BondCount << ", no bonds between any of the " << AtomCount << " atoms." << endl;
+    *out << Verbose(1) << "I detected " << BondCount << " bonds in the molecule with distance " << bonddistance << ", " << FalseBondDegree << " bonds could not be corrected." << endl;
+
+    // output bonds for debugging (if bond chain list was correctly installed)
+    *out << Verbose(1) << endl << "From contents of bond chain list:";
+    bond *Binder = first;
+    while(Binder->next != last) {
+      Binder = Binder->next;
+      *out << *Binder << "\t" << endl;
+    }
+    *out << endl;
+  } else
+    *out << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl;
+  *out << Verbose(0) << "End of CreateAdjacencyList." << endl;
+  Free((void **)&matrix, "molecule::CreateAdjacencyList: *matrix");
 
 };
